Bug 1015391 - gnome-online-accounts not validating/sanitising input, goa-daemon continually seg faults if errors present in accounts.conf [NEEDINFO]
gnome-online-accounts not validating/sanitising input, goa-daemon continually...
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: gnome-online-accounts (Show other bugs)
19
Unspecified Linux
unspecified Severity medium
: ---
: ---
Assigned To: Debarshi Ray
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-04 02:00 EDT by Anthony Horton
Modified: 2015-02-17 12:30 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 12:30:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
debarshir: needinfo? (anthony.horton)


Attachments (Terms of Use)

  None (edit)
Description Anthony Horton 2013-10-04 02:00:57 EDT
Description of problem:

gnome-online-accounts is not validating/sanitising the input from the ~/.config/goa-1.0/accounts.conf config file.  If there are errors present in this file such that it contains an incomplete/invalid account description then /usr/libexec/goa-daemon will simply segmentation fault every time accounts.conf is parsed.  It is not straightforward for the end user to recover from this situation because the Online Accounts section of GNOME Settings becomes completely inoperable (empty accounts list with all buttons greyed out) and neither the error notifications ("A problem has been reported with gnome-online-accounts") nor the reports from ABRT ("/usr/libexec/goa-daemon has exited with signal 11 (SIGSEGV)") give much of a clue as to exactly what the problem is.  The only way to recover from this situation is to manually edit/delete the accounts.conf file.

It might be argued that this is an unlikely scenario but this is exactly what happened to me, following a distribution upgrade I somehow ended up with a truncated accounts.conf file that contained only part of an account description.  The whole Online Accounts system was then completely inoperable until I manually deleted the file.  There are many ways in which ordinary files on disk can become corrupted so input from such files should always be validated/sanitised, just because a config file isn't intended to be manually edited doesn't mean you can assume it will only ever contain valid data.


Version-Release number of selected component (if applicable): 3.8.3-3.fc19


How reproducible: Always


Steps to Reproduce:
1. Edit ~/.config/goa-1.0/accounts.conf so that it contains an incomplete or invalid account description (or get a disk error to do this for you).
2. Login to GNOME or open the Online Accounts settings.

Actual results:

/usr/libexec/goa-daemon segmentation faults every time ~/.config/goa-1.0/accounts.conf is parsed and the Online Accounts system becomes completely inoperable until the accounts.conf file is manually repaired or removed.


Expected results:

The incomplete/invalid account description is detected, rejected, and reported to the user.  Any complete and valid account descriptions in accounts.conf are processed as normal.  The Online Accounts system continues to work.



Additional info:
Comment 1 Debarshi Ray 2014-04-10 05:18:53 EDT
Do you have a sample accounts.conf that triggers a crash? There are no secret credentials in accounts.conf so it should be safe to attach it.
Comment 2 Fedora End Of Life 2015-01-09 15:06:50 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2015-02-17 12:30:18 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.